EAPI EAPI_WEAK const Efl_Event_Description _EFL_GFX_ENTITY_EVENT_VISIBILITY_CHANGED =
   EFL_EVENT_DESCRIPTION("visibility,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_GFX_ENTITY_EVENT_POSITION_CHANGED =
   EFL_EVENT_DESCRIPTION("position,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_GFX_ENTITY_EVENT_SIZE_CHANGED =
   EFL_EVENT_DESCRIPTION("size,changed");
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_entity_position_set, EFL_FUNC_CALL(pos), Eina_Position2D pos);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_entity_position_get, Eina_Position2D, ((Eina_Position2D){0}));
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_entity_size_set, EFL_FUNC_CALL(size), Eina_Size2D size);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_entity_size_get, Eina_Size2D, ((Eina_Size2D){0}));
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_entity_geometry_set, EFL_FUNC_CALL(rect), Eina_Rect rect);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_entity_geometry_get, Eina_Rect, (EINA_RECT_EMPTY()));

static Eina_Error
__eolian_efl_gfx_entity_visible_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_entity_visible_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_entity_visible_set, EFL_FUNC_CALL(v), Eina_Bool v);

static Eina_Value
__eolian_efl_gfx_entity_visible_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_gfx_entity_visible_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_entity_visible_get, Eina_Bool, 0);

static Eina_Error
__eolian_efl_gfx_entity_scale_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_entity_scale_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_entity_scale_set, EFL_FUNC_CALL(scale), double scale);

static Eina_Value
__eolian_efl_gfx_entity_scale_get_reflect(const Eo *obj)
{
   double val = efl_gfx_entity_scale_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_entity_scale_get, double, 0.000000);

static Eina_Bool
_efl_gfx_entity_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_GFX_ENTITY_EXTRA_OPS
#define EFL_GFX_ENTITY_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_position_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_position_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_size_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_size_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_geometry_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_geometry_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_visible_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_visible_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_scale_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_scale_get, NULL),
      EFL_GFX_ENTITY_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"visible", __eolian_efl_gfx_entity_visible_set_reflect, __eolian_efl_gfx_entity_visible_get_reflect},
      {"scale", __eolian_efl_gfx_entity_scale_set_reflect, __eolian_efl_gfx_entity_scale_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_gfx_entity_class_desc = {
   EO_VERSION,
   "Efl.Gfx.Entity",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_gfx_entity_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_gfx_entity_interface_get, &_efl_gfx_entity_class_desc, NULL, NULL);
